# Ogre::VectorIterator< T > Class Template Reference

Concrete IteratorWrapper for nonconst access to the underlying container. More...

`#include <OgreIteratorWrapper.h>`

Inheritance diagram for Ogre::VectorIterator< T >:
[legend]

List of all members.

## Public Types

typedef IteratorWrapper< T, T::iterator, typename T::value_type >::ValueType | ValueType
| type you expect to get by funktions like peekNext(Value)
typedef IteratorWrapper< T, T::iterator, typename T::value_type >::PointerType | PointerType
| type you expect to get by funktions like peekNext(Value)Ptr
typedef T::iterator | iterator
| typedef to fulfill container interface
typedef T::iterator | const_iterator
| typedef to fulfill container interface

## Public Member Functions

| VectorIterator (typename T::iterator start, typename T::iterator last)
| Constructor.
| VectorIterator (T &c)
| Constructor.
ValueType | peekNext () const
| Returns the next(=current) element in the collection, without advancing to the next.
PointerType | peekNextPtr () const
| Returns a pointer to the next(=current) element in the collection, without advancing to the next afterwards.
ValueType | getNext ()
| Returns the next(=current) value element in the collection, and advances to the next.
bool | hasMoreElements () const
| Returns true if there are more items in the collection.
void | moveNext ()
| Moves the iterator on one element.
const T::iterator & | begin ()
| bookmark to the begin of the underlying collection
T::iterator & | current ()
| full access to the current iterator
const T::iterator & | end ()
| bookmark to the end (one behind the last element) of the underlying collection

## Protected Attributes

T::iterator | mBegin
T::iterator | mCurrent
T::iterator | mEnd

## Detailed Description

### template<typename T>
class Ogre::VectorIterator< T >

Concrete IteratorWrapper for nonconst access to the underlying container.

Parameters:

  | T | Container

Definition at line 188 of file OgreIteratorWrapper.h.

## Member Typedef Documentation

typedef T::iterator Ogre::IteratorWrapper< T, T::iterator , T::value_type >::const_iterator `[inherited]`

typedef to fulfill container interface

Userfull if you want to use BOOST_FOREACH

Note:
  there is no distinction between const_iterator and iterator.
  keep this in mind if you want to derivate from this class.

Definition at line 82 of file OgreIteratorWrapper.h.

typedef T::iterator Ogre::IteratorWrapper< T, T::iterator , T::value_type >::iterator `[inherited]`

typedef to fulfill container interface

Userfull if you want to use BOOST_FOREACH

Note:
  there is no distinction between const_iterator and iterator.
  keep this in mind if you want to derivate from this class.

Definition at line 73 of file OgreIteratorWrapper.h.

typedef IteratorWrapper<T, T::iterator , typename T::value_type>::PointerType Ogre::VectorIteratorWrapper< T, T::iterator >::PointerType `[inherited]`

type you expect to get by funktions like peekNext(Value)Ptr

Reimplemented from Ogre::IteratorWrapper< T, T::iterator, T::value_type >.

Definition at line 142 of file OgreIteratorWrapper.h.

typedef IteratorWrapper<T, T::iterator , typename T::value_type>::ValueType Ogre::VectorIteratorWrapper< T, T::iterator >::ValueType `[inherited]`

type you expect to get by funktions like peekNext(Value)

Reimplemented from Ogre::IteratorWrapper< T, T::iterator, T::value_type >.

Definition at line 141 of file OgreIteratorWrapper.h.

## Constructor & Destructor Documentation

template<typename T >

Ogre::VectorIterator< T >::VectorIterator | ( | typename T::iterator | start,
|  | typename T::iterator | last |
| ) |  |  |

Constructor.

Remarks:
  Provide a start and end iterator to initialise.

Definition at line 194 of file OgreIteratorWrapper.h.

template<typename T >

Ogre::VectorIterator< T >::VectorIterator | ( | T & | c | ) | `[explicit]`

Constructor.

Remarks:
  Provide a container to initialise.

Definition at line 203 of file OgreIteratorWrapper.h.

## Member Function Documentation

const T::iterator & Ogre::IteratorWrapper< T, T::iterator , T::value_type >::begin | ( |  | ) | `[inherited]`

bookmark to the begin of the underlying collection

Definition at line 112 of file OgreIteratorWrapper.h.

T::iterator & Ogre::IteratorWrapper< T, T::iterator , T::value_type >::current | ( |  | ) | `[inherited]`

full access to the current iterator

Definition at line 116 of file OgreIteratorWrapper.h.

const T::iterator & Ogre::IteratorWrapper< T, T::iterator , T::value_type >::end | ( | void |  | ) | `[inherited]`

bookmark to the end (one behind the last element) of the underlying collection

Definition at line 119 of file OgreIteratorWrapper.h.

ValueType Ogre::VectorIteratorWrapper< T, T::iterator >::getNext | ( | void |  | ) | `[inherited]`

Returns the next(=current) value element in the collection, and advances to the next.

Definition at line 172 of file OgreIteratorWrapper.h.

bool Ogre::IteratorWrapper< T, T::iterator , T::value_type >::hasMoreElements | ( |  | ) | const`[inherited]`

Returns true if there are more items in the collection.

Definition at line 99 of file OgreIteratorWrapper.h.

void Ogre::IteratorWrapper< T, T::iterator , T::value_type >::moveNext | ( |  | ) | `[inherited]`

Moves the iterator on one element.

Definition at line 106 of file OgreIteratorWrapper.h.

ValueType Ogre::VectorIteratorWrapper< T, T::iterator >::peekNext | ( |  | ) | const`[inherited]`

Returns the next(=current) element in the collection, without advancing to the next.

Definition at line 160 of file OgreIteratorWrapper.h.

PointerType Ogre::VectorIteratorWrapper< T, T::iterator >::peekNextPtr | ( |  | ) | const`[inherited]`

Returns a pointer to the next(=current) element in the collection, without advancing to the next afterwards.

Definition at line 166 of file OgreIteratorWrapper.h.

## Member Data Documentation

T::iterator Ogre::IteratorWrapper< T, T::iterator , T::value_type >::mBegin `[protected, inherited]`

Definition at line 54 of file OgreIteratorWrapper.h.

T::iterator Ogre::IteratorWrapper< T, T::iterator , T::value_type >::mCurrent `[protected, inherited]`

Definition at line 55 of file OgreIteratorWrapper.h.

T::iterator Ogre::IteratorWrapper< T, T::iterator , T::value_type >::mEnd `[protected, inherited]`

Definition at line 56 of file OgreIteratorWrapper.h.

The documentation for this class was generated from the following file:

- OgreIteratorWrapper.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:56